package kiekerdays.tcpreader;

import kiekerdays.CounterActor;
import kiekerdays.StartMessage;
import kiekerdays.StopMessage;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import akka.actor.ActorRef;
import akka.actor.ActorSelection;
import akka.actor.ActorSystem;
import akka.actor.PoisonPill;
import akka.actor.Props;

public class TcpReaderAnalysisConfiguration {

	private static final Logger LOGGER = LoggerFactory.getLogger(TcpReaderAnalysisConfiguration.class);

	private ActorRef tcpReaderActor;
	private ActorRef rootActor;

	public TcpReaderAnalysisConfiguration() {
		init();
	}

	private void init() {
		ActorSystem system = ActorSystem.create("TraceReductionAnalysisConfiguration");

		// specify actors
		Props counterProps = Props.create(CounterActor.class);
		Props tcpReaderProps = Props.create(TcpReaderActor.class, counterProps);

		// create actors
		final ActorRef tcpReaderActor = system.actorOf(tcpReaderProps, "TcpReaderActor");
		// final ActorRef tcpTraceReconstructonActor = system.actorOf(tcpTraceReconstructionProps, "TcpTraceReconstructionActor");
		// final ActorRef validTraceReceiver = system.actorOf(collectorValidProps, "CollectorValid");
		// final ActorRef invalidTraceReceiver = system.actorOf(collectorInvalidProps, "CollectorInvalid");
		// final ActorRef tcpReaderActor = system.actorOf(Props.create(TcpReaderActor.class,
		// new Creator<TcpReaderActor>() {
		// @Override
		// public TcpReaderActor create() throws Exception {
		// return new TcpReaderActor(tcpTraceReconstructonActor);
		// }
		// }));

		// tcpReader = TypedActor.get(system).typedActorOf(new TypedProps<TcpReaderActor>(ITcpReader.class, new
		// Creator<TcpReaderActor>() {
		// @Override
		// public TcpReaderActor create() throws Exception {
		// return new TcpReaderActor(tcpTraceReconstructonActor);
		// }
		// }));

		this.tcpReaderActor = tcpReaderActor;

		ActorSelection rootActorSelection = system.actorSelection(tcpReaderActor.path().root());
		rootActor = rootActorSelection.anchor();

		LOGGER.info("Configuration initialized.");
	}

	public void start() throws Exception {
		LOGGER.info("Starting analysis...");
		// tcpReader.onStarting();
		// tcpReader.execute();
		// tcpReader.onTerminating();
		tcpReaderActor.tell(new StartMessage(), ActorRef.noSender());
		LOGGER.info("Analysis started.");

		tcpReaderActor.tell(new StopMessage(), ActorRef.noSender());

		rootActor.tell(PoisonPill.getInstance(), rootActor);
		// tcpReaderActor.parent().tell(PoisonPill.getInstance(), getSelf());
		// Future<Terminated> future = system.terminate();
		// Await.ready(future, Duration.Inf());
		LOGGER.info("Analysis stopped.");
	}

}
